<?php
if(!defined('PLX_ROOT')) exit('Fuck !');

/*
 * Suppression de la fonction self::__getFolders(..) trop lente à l'exécution.
 * Dans config.php, on passe $plxAdmin en paramètre à la fonction self::__getFolders(..)
 * pour éviter un bug si le plugin n'est pas activé.
 * */

class kzDownload extends plxPlugin {

	const CLASS_HTML_MASK = '@class="([^"]+)"@';
	const MARK = 'data-download';
	const PARAM = 'download-folder';
	const WEEK_DURATION = 604800; // 3600 * 24 * 7;
	const STATS_PERIODE = 7948800; // = 3600 * 24 * (31 + 30 + 31) ~ 3 mois
	const WEEKS_MAX = 6; /* for admin.php */
	const DATE_FORMAT = 'y\WW';

	const CODE_BEGIN = '<?php' . PHP_EOL;
	const CODE_END = PHP_EOL . '?>';

	const XML_HEADER = '<?xml version="1.0" encoding="' . PLX_CHARSET . '" ?>' . PHP_EOL;

	public $mediasRoot;

	public function __construct($lang) {
		parent::__construct($lang);
		parent::addHook('plxMotorConstruct', 'plxMotorConstruct');

		$configFilename = $this->plug['parameters.xml'];
		if(defined('PLX_ADMIN')) {
			parent::setConfigProfil(PROFIL_ADMIN);
			parent::setAdminProfil(PROFIL_ADMIN);
			parent::setAdminMenu(parent::getLang('MENU_NAME'), 0, parent::getLang('MENU_TITLE'));
		} elseif(file_exists($configFilename)) {
			// Le plugin a été configuré : un dossier pour le téléchargement est défini.
			foreach(array('ThemeEndBody', 'plxMotorSendDownload') as $hook) {
				parent::addHook($hook, $hook);
			}

			// Hack against PluXml : absolute path is required for saving from the front end.
			$this->plug['parameters.xml'] = realpath($configFilename);
		}
	}

	// Fork of plxPlugin::saveParams() from PluXml
	public function saveParams() {
		ob_start();
		# Début du fichier XML
?>
<document>
<?php
		foreach($this->aParams as $name=>$param) {
			$type = $param['type'];
			switch($type) {
				case 'numeric':
?>
	<parameter name="<?= $name ?>" type="numeric"><?= intval($param['value']) ?></parameter>
<?php
					break;
				case 'string':
?>
	<parameter name="<?= $name ?>" type="string"><?= plxUtils::cdataCheck(plxUtils::strCheck($param['value'])) ?></parameter>
<?php
					break;
				default:
?>
	<parameter name="<?= $name ?>" type="cdata"><![CDATA[<?= plxUtils::cdataCheck($param['value']) ?>]]></parameter>
<?php
					break;
			}
		}
?>
</document>
<?php
		# Fin du fichier XML

		# On écrit le fichier
		if(plxUtils::write(self::XML_HEADER . ob_get_clean(), $this->plug['parameters.xml'])) {
			# suppression ancien fichier parameters.xml s'il existe encore (5.1.7+)
			if(file_exists($this->plug['dir'].$this->plug['name'] . '/parameters.xml'))
				unlink($this->plug['dir'] . $this->plug['name'] . '/parameters.xml');
			return (class_exists('plxMsg')) ? plxMsg::Info(L_SAVE_SUCCESSFUL) : true;
		}
		else
			return (class_exists('plxMsg')) ? plxMsg::Error(L_SAVE_ERR . ' ' . $this->plug['parameters.xml']) : false;
	}

	private function __byteConvert($bytes) {
	    if ($bytes == 0) { return "0.00&nbsp;"; }

	    $s = array('&nbsp;', 'K', 'M', 'G', 'T', 'P');
	    $e = floor(log($bytes, 1024));

	    return round($bytes/pow(1024, $e), 2).$s[$e];
	}

	private function __build_gallery($folder) {
		$ext_filename = __DIR__ .'/mime-types/extensions.json';
		$substitutes_filename = __DIR__ . '/icons/substitutes.txt';

		$default_mime_types = array(
			'application/octet-stream',
			'text/plain'
		);
		$folder = trim($folder, '/').'/';
		$root = $this->mediasRoot.$folder;
		$glob = plxGlob::getInstance($root);
		if ($files = $glob->query('@[\w-]+\.\w+$@')) {
			sort($files);

			$description_filename = $root . '.htaccess';
			$descriptions = array();
			if(file_exists($description_filename)) {
			    if(preg_match_all(
					'@^AddDescription\s+"([^"]+)"\s+(.+)$@m',
					file_get_contents($description_filename),
					$matches,
					PREG_SET_ORDER)
				) {
			        foreach($matches as $capture) {
			            $descriptions[$capture[2]] = $capture[1];
			        }
			    }
			}

			ob_start();
?>
	<div class="scrollable-table"><table class="<?= __CLASS__ ?>-filelist">
		<thead>
			<tr>
				<th></th>
<?php
		$titles = array();
		foreach(explode(' ', 'FILENAME DATE SIZE DESCRIPTION') as $t) {
?>
				<th><?= $this->getLang($t) ?></th>
<?php
		}
?>
			</tr>
		</thead>
		<tbody>
<?php
			$contentRows = array();
			$finfo = finfo_open(FILEINFO_MIME_TYPE);
			$extensions = (function_exists('json_decode') and file_exists($ext_filename));
			$substitutes = true;
			$prefix = (!empty($this->urlRewriting)) ? 'download/' : 'index.php?download/';
			foreach($files as $filename) {
				$path1 = $root.$filename;
				$href = $prefix.plxEncrypt::encryptId(substr($path1,  $this->offsetRoot));
				$mime_type = finfo_file($finfo, $path1);
				$ext = pathinfo($path1,  PATHINFO_EXTENSION);
				if(
					$ext != 'txt' and
					in_array($mime_type, $default_mime_types) and
					$extensions !== false
				) {
					if($extensions === true) {
						$extensions = json_decode(file_get_contents($ext_filename), true);
					}
					if(array_key_exists($ext, $extensions)) {
						$mime_type = $extensions[$ext];
					}
				}
				$icon_name = str_replace('/', '-', $mime_type);
				$src = "/icons/$icon_name.png";
				if(!file_exists(__DIR__ . $src)) {
					$src = "/icons/$ext.png";
					if(!file_exists(__DIR__ . $src)) {
						if($substitutes === true) {
							// voir pour une correspondance avec un autre mime-type
							if(file_exists($substitutes_filename)) {
								$content = file($substitutes_filename);
								$substitutes = array();
								foreach($content as $line) {
									list($key, $value) = explode("\t", $line, 2);
									if($key != trim($value)) {
										$substitutes[$key] = trim($value);
									}
								}
							} else {
								$substitutes = false;
							}
						}
						if(
							is_array($substitutes) and
							array_key_exists($icon_name, $substitutes)
						) {
							$src = "/icons/{$substitutes[$icon_name]}.png";
						} else {
							$parts = explode('/', $mime_type);
							$src = "/icons/{$parts[0]}-x-generic.png";
						}
					}
				}
				$src = PLX_PLUGINS . '/' . __CLASS__ . "$src";
		        $time = date('Y-m-d H:i', filemtime($path1));
		        $icon = '&nbsp;';
		        $size = self::__byteConvert(filesize($path1));
		        $description = (array_key_exists($filename, $descriptions)) ? $descriptions[$filename] : '';
?>
	   	     <tr>
    	        <td><img src="<?= $src ?>" width="32" height="32" alt="<?= $ext ?>" title="<?= $mime_type ?>" /></td>
    	        <td><a href="<?= $href ?>" rel="noreferrer nofollow" download><?= $filename ?></a></td>
    	        <td><?= $time ?></td>
    	        <td><?= $size ?></td>
    	        <td><?= $description ?></td>
	        </tr>
<?php
			}
			finfo_close($finfo);
			$rows = implode("\n", $contentRows);
		} else {
			// No file
?>
			<tr colspan="5"><td><?= $this->getLang('NO_FILE') ?></td></tr>
<?php
		}
?>
		</tbody>
	</table></div>
<?php
		return ob_get_clean();
	}

	/*
	 * Ajoute un attribut download à la balise <a> si besoin
	 * */
	private function __addDownloadAttribute($link) {
		// On retire temporairement certains attributs pouvant contenir le mot download
		$temp = preg_replace('@\s*((?:href|class|rel|data-\w+)="[^"]*")@', '', $link);
		// on contrôle si le mot download est présent après simplification
		return preg_match('@\bdownload\b@', $temp) ? $link : $link . ' download';
	}

	public function replace($matches) {
		$prefix = (!empty($this->urlRewriting)) ? 'download/' : 'index.php?download/';
		if(!empty($matches[2])) {
			$href = $prefix . plxEncrypt::encryptId(substr($matches[2], $this->offsetRoot));
			return self::__addDownloadAttribute($matches[1] . $href . $matches[3]);
		} elseif(!empty($matches[5])) {
			return $matches[4] . self::__build_gallery($matches[5]);
		} elseif(!empty($matches[7])) {
			$href = $prefix.plxEncrypt::encryptId(substr($matches[7], $this->offsetRoot));
			return self::__addDownloadAttribute($matches[6] . $href . $matches[8]);
		}
	}

	public function getFolders(&$plxAdmin) {
		$root = PLX_ROOT.$plxAdmin->aConf['medias'];
		if(
			$_SESSION['profil'] == PROFIL_WRITER and
			!empty($_SESSION['user']) and
			!empty($plxAdmin->aConf['userfolders'])
		) {
			$root .= "${_SESSION['user']}/";
		}
		$folders = array();
		$root = rtrim($root, '/');
		$offset = strlen($root);
		$pattern = '/*';
		for($i=1, $iMax=11; $i <$iMax; $i++) {
			$temp = glob($root.str_repeat($pattern, $i), GLOB_ONLYDIR);
			if(empty($temp)) { break; }
			$folders = array_merge($folders, $temp);
		}
		$result = array_map(function($item) use($offset) {
			return substr($item, $offset);
		}, $folders);
		sort($result);
		return $result;
	}

	public function stats($filename) {
		# check if file_exists !

		if(empty($filename)) { return; }

		$datas = trim($this->getParam('stats'));
		if(!empty($datas)) {
			$stats = (function_exists('json_decode')) ? json_decode($datas, true) : $stats = unserialize($datas);
		} else {
			$stats = array();
		}
		$week = date(self::DATE_FORMAT);
		if(!empty($stats[$filename])) {
			if(!array_key_exists($week, $stats[$filename]['weeks'])) {
				$stats[$filename]['weeks'][$week] = 1;
			} else {
				$stats[$filename]['weeks'][$week]++;
			}
			$stats[$filename]['cumul']++;

			// Drop outdated weeks for this filename
			$from = date(self::DATE_FORMAT, time() - self::STATS_PERIODE);
			foreach(array_keys($stats[$filename]['weeks']) as $week1) {
				if($week1 < $from) {
					unset($stats[$filename]['weeks'][$week1]);
				}
			}
			krsort($stats[$filename]['weeks']);
		} else {
			$stats[$filename] = array(
				'weeks'		=> array($week => 1),
				'cumul'		=> 1,
				'published'	=> date('Y-m-d')
			);
		}

		$this->setParam(
			'stats',
			(function_exists('json_encode') ? "\n".json_encode($stats, JSON_PRETTY_PRINT | JSON_UNESCAPED_SLASHES)."\n" : serialize($stats)),
			'cdata'
		);
		$this->saveParams();
	}

	public function deleteStats($inputName) {
		$datas = trim($this->getParam('stats'));
		if(empty($datas)) { return; }

		$filelist = filter_input(INPUT_POST, $inputName, FILTER_SANITIZE_STRING, FILTER_REQUIRE_ARRAY);
		$stats = (function_exists('json_decode')) ? json_decode($datas, true) : $stats = unserialize($datas);
		$updated = false;
		foreach($filelist as $filename) {
			if(array_key_exists($filename, $stats)) {
				unset($stats[$filename]);
				$updated = true;
			}
		}
		if($updated) {
			$this->setParam(
				'stats',
				(function_exists('json_encode') ? "\n".json_encode($stats, JSON_PRETTY_PRINT | JSON_UNESCAPED_SLASHES)."\n" : serialize($stats)),
				'cdata'
			);
			$this->saveParams();
		}
	}

/* ========== Hooks =============== */

	public function plxMotorConstruct() {
		echo self::CODE_BEGIN;
?>
$kzPlugin = $this->plxPlugins->aPlugins['<?= __CLASS__ ?>'];
$kzPlugin->mediasRoot = $this->aConf['medias'];
$kzPlugin->offsetRoot = strlen($this->aConf['medias']);
$kzPlugin->mediasUser = (
	!empty($this->aConf['userfolders']) and
	!empty($_SESSION['user']) and
	$_SESSION['profil'] == PROFIL_WRITER
) ? "${_SESSION['user']}/" : '';
$kzPlugin->urlRewriting = !empty($this->aConf['urlrewriting']);
<?php
		echo self::CODE_END;
	}

	/*
	 * Encrypts the url in href attribute or builds a file list for downloading nested in a table
	 * */
	public function ThemeEndBody() {
		global $output;

		$masks = array(
			// href for encrypting in an <a> tag with a data-download or download attribute
			'(<a\b[^>]*\shref=")([^"]+)(".*\s(?:' . self::MARK . '|download)\b[^>]*)',
			// filelist for downloading. The folder is set in the data-download attribute.
			'(<div(?:\s+\w+[^>]*)?\s+' . self::MARK . '="([^"]+)"(?:\s+[^>]*)?>)(?:[^<]*)',
		);
		// href starts with path of folder for downloading
		$folder = ltrim($this->getParam(self::PARAM), '/');
		if(!empty($folder)) {
			$path1  = str_replace('.', '\.', $this->mediasRoot . $folder);
			$masks[] = <<< PATH1_MASK
(<a\b[^>]*\shref=")(${path1}[^"]+)("[^>]*)
PATH1_MASK;
		}

		$output = preg_replace_callback('@(?:' . implode('|', $masks) . ')@', array($this, 'replace'), $output);
	}

	/**
	 * For counting each downloading file.
	 * */
	public function plxMotorSendDownload() {
		echo self::CODE_BEGIN;
?>
$this->plxPlugins->aPlugins['<?= __CLASS__ ?>']->stats(
	substr(
		$file,
		strlen(PLX_ROOT.$this->aConf['medias'])
	)
);
return false;
<?php
		echo self::CODE_END;
	}
}
