<div class="<?php echo $page; ?>-help">
<p> This plugin allows you to hide the url of files available for download in an article or a static page.</p>
<p>There are two possible uses :</p>
<ul>
<li><p>We select in the control panel, the folder where the files to download are stored.</p>
<p>We select in the control panel, the folder where the files to download are stored.</p>
<p>When saving the article, the link will be marked with the <em> data-download </em> attribute</p>
<p>When displayed on the site, the plugin will automatically encrypt the url of the files (<em> Value of the href attribute in the & lt; a & gt; tag) for all the links previously marked </em>. In addition, it is possible to change the folder for other articles or static pages.</p>
</li>
<li>If you want to offer several files to download in the form of a nice table, you can insert the following code in the article or the static page :</li>
<pre><code>&lt;div class="ma-class" data-download="folder-from-downloading-files"&gt;
   Location for the table
&lt;/div&gt;</code></pre>
<p>Before display, the content of the &lt;div&gt; will be replaced by an array listing the name of the files to download found in the folder specified by the <em> data-download </em> attribute with the value of their encrypted href attributes. The sizes and modification dates are also specified.</p>
<p>The folder path must be specified relative to the media folder (<em> by default: / datas / medias / </em>).</p>
<p>Also, if an <em> .htaccess </em> file is present in the folder with directives <a href = "https://httpd.apache.org/docs/2.4/mod/mod_a utoindex.html # adddescription "target =" _ blank "> AddDescription </a>, a description will be added to each file concerned.</p>
</ul>
<p class="kzDownload-warning">If a malicious user manages to install in your data folder, <em> data </em>, a malicious PHP file, he will be able to execute it without problem to recover your data of interest.</p>
<p>To avoid this peril, you just need to modify the <strong> .htaccess </strong> file, located in your folder, to prevent the execution of any PHP script as follows:</p>
<pre><code>options -indexes
&lt;Files "*"&gt;
        SetHandler default-handler
&lt;/Files&gt;
</code></pre>
<p>The plugin also records the total number of clicks for each download url with a weekly detail over a three month period.</p>
<p>File popularity can be presented as a graph for all of all files over that time period.</p>
</div>
